
#include "Castle.h"

Castle::Castle()
{

}

Castle::~Castle()
{
}

int Castle::build_castle()
{
  int ok=0;

  //****************************// 
  //FACE
  //****************************// 

  int N_theta=10,N_h=10;
  //create cylinder
  ok += mesh_cylinder_1.create_cylinder(N_theta,N_h,0.2,1.2);
  ok += mesh_cylinder_1.map_linear_texture_coordinate(N_theta,N_h,3,3);
  ok += mesh_cylinder_1.translate(0,WATER_LEVEL,0);


  //create cone
  N_theta=20;N_h=10;
  ok += mesh_lamp_cone.create_cone(N_theta,N_h,0.01,0.03,0.03);
  ok += mesh_lamp_cone.translate(0,WATER_LEVEL,0);
  ok += mesh_lamp_cone.translate(0.27,0.18,-0.07);
  ok += mesh_lamp_cone.build_normal();
  ok += mesh_lamp_cone.map_linear_texture_coordinate(N_theta,N_h,1,1);

  //create cylinder for the fire
  ok += mesh_lamp_cylinder.create_cylinder(N_theta,N_h,0.01,0.18);
  ok += mesh_lamp_cylinder.translate(0,WATER_LEVEL,0);
  ok += mesh_lamp_cylinder.translate(0.27,0.00,-0.07);
  ok += mesh_lamp_cylinder.build_normal();
  ok += mesh_lamp_cylinder.map_linear_texture_coordinate(N_theta,N_h,1,1);



  //build draw list
  ok += build_draw_list();


  return ok;
}

int Castle::build_draw_list()
{
  int ok=0;
  float lambda_castle=5;

  if(glIsList(draw_list))
    glDeleteLists(draw_list,1);
  draw_list = glGenLists(1);
  glNewList(draw_list,GL_COMPILE);





  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_number[0]);


  glBegin(GL_QUADS);
  glColor3f(1.0,1.0,1.0);
  glTexCoord2f(0*lambda_castle,0*lambda_castle); glVertex3f(0,0+WATER_LEVEL,0);
  glTexCoord2f(1*lambda_castle,0*lambda_castle); glVertex3f(1,0+WATER_LEVEL,0);
  glTexCoord2f(1*lambda_castle,1*lambda_castle); glVertex3f(1,1+WATER_LEVEL,0);
  glTexCoord2f(0*lambda_castle,1*lambda_castle); glVertex3f(0,1+WATER_LEVEL,0);

  glColor3f(0.4,0.4,0.4);
  glTexCoord2f(0*lambda_castle,0*lambda_castle); glVertex3f(0,0+WATER_LEVEL,1);
  glTexCoord2f(1*lambda_castle,0*lambda_castle); glVertex3f(1,0+WATER_LEVEL,1);
  glTexCoord2f(1*lambda_castle,1*lambda_castle); glVertex3f(1,1+WATER_LEVEL,1);
  glTexCoord2f(0*lambda_castle,1*lambda_castle); glVertex3f(0,1+WATER_LEVEL,1);

  glTexCoord2f(0*lambda_castle,0*lambda_castle); glVertex3f(0,0+WATER_LEVEL,0);
  glTexCoord2f(1*lambda_castle,0*lambda_castle); glVertex3f(0,0+WATER_LEVEL,1);
  glTexCoord2f(1*lambda_castle,1*lambda_castle); glVertex3f(0,1+WATER_LEVEL,1);
  glTexCoord2f(0*lambda_castle,1*lambda_castle); glVertex3f(0,1+WATER_LEVEL,0);

  glTexCoord2f(0*lambda_castle,0*lambda_castle); glVertex3f(1,0+WATER_LEVEL,0);
  glTexCoord2f(1*lambda_castle,0*lambda_castle); glVertex3f(1,0+WATER_LEVEL,1);
  glTexCoord2f(1*lambda_castle,1*lambda_castle); glVertex3f(1,1+WATER_LEVEL,1);
  glTexCoord2f(0*lambda_castle,1*lambda_castle); glVertex3f(1,1+WATER_LEVEL,0);
  glEnd();


  //set memory for vertex,normal and texture
  glEnableClientState(GL_VERTEX_ARRAY);
  glEnableClientState(GL_TEXTURE_COORD_ARRAY);




  int k_x=0,k_y=0;
  for(k_x=0;k_x<=1;k_x++)
    for(k_y=0;k_y<=1;k_y++)
      {
	glPushMatrix();
	glTranslatef(k_x,0.0,k_y);

	//cylinder
	glVertexPointer(3,GL_FLOAT,0,mesh_cylinder_1.get_vertex());
	glTexCoordPointer(2,GL_FLOAT,0,mesh_cylinder_1.get_texture_coordinate());
	glDrawElements(GL_TRIANGLES,mesh_cylinder_1.get_N_triangle()*3,GL_UNSIGNED_INT,mesh_cylinder_1.get_connectivity());
	
	glPopMatrix();
      }






  //lamp
  glEnableClientState(GL_NORMAL_ARRAY);
  glBindTexture(GL_TEXTURE_2D, texture_number[3]);
  glVertexPointer(3,GL_FLOAT,0,mesh_lamp_cone.get_vertex());
  glNormalPointer(GL_FLOAT,0,mesh_lamp_cone.get_normal());
  glTexCoordPointer(2,GL_FLOAT,0,mesh_lamp_cone.get_texture_coordinate());
  glDrawElements(GL_TRIANGLES,mesh_lamp_cone.get_N_triangle()*3,GL_UNSIGNED_INT,mesh_lamp_cone.get_connectivity());

  glVertexPointer(3,GL_FLOAT,0,mesh_lamp_cylinder.get_vertex());
  glNormalPointer(GL_FLOAT,0,mesh_lamp_cylinder.get_normal());
  glTexCoordPointer(2,GL_FLOAT,0,mesh_lamp_cylinder.get_texture_coordinate());
  glDrawElements(GL_TRIANGLES,mesh_lamp_cylinder.get_N_triangle()*3,GL_UNSIGNED_INT,mesh_lamp_cylinder.get_connectivity());

  glPushMatrix();
  glTranslatef(0.48,0.0,0.0);
  glVertexPointer(3,GL_FLOAT,0,mesh_lamp_cone.get_vertex());
  glNormalPointer(GL_FLOAT,0,mesh_lamp_cone.get_normal());
  glTexCoordPointer(2,GL_FLOAT,0,mesh_lamp_cone.get_texture_coordinate());
  glDrawElements(GL_TRIANGLES,mesh_lamp_cone.get_N_triangle()*3,GL_UNSIGNED_INT,mesh_lamp_cone.get_connectivity());

  glVertexPointer(3,GL_FLOAT,0,mesh_lamp_cylinder.get_vertex());
  glNormalPointer(GL_FLOAT,0,mesh_lamp_cylinder.get_normal());
  glTexCoordPointer(2,GL_FLOAT,0,mesh_lamp_cylinder.get_texture_coordinate());
  glDrawElements(GL_TRIANGLES,mesh_lamp_cylinder.get_N_triangle()*3,GL_UNSIGNED_INT,mesh_lamp_cylinder.get_connectivity());

  glPopMatrix();
  glDisableClientState(GL_NORMAL_ARRAY);



  glDisableClientState(GL_VERTEX_ARRAY);
  glDisableClientState(GL_TEXTURE_COORD_ARRAY);





  glDisable(GL_FOG);
  //door
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glBindTexture(GL_TEXTURE_2D, texture_number[1]);
  glColor3f(1.0,1.0,1.0);
  glPushMatrix();
  glTranslatef(0.0,WATER_LEVEL,0.0);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0,1.0); glVertex3f(0.3,0.0,0.0-0.001);
  glTexCoord2f(0.0,0.0); glVertex3f(0.3,0.5,0.0-0.001);
  glTexCoord2f(1.0,0.0); glVertex3f(0.7,0.5,0.0-0.001);
  glTexCoord2f(1.0,1.0); glVertex3f(0.7,0.0,0.0-0.001);
  glEnd();
  glPopMatrix();
  glDisable(GL_BLEND);



  glEnable(GL_FOG);



  glDisable(GL_TEXTURE_2D);
  glEndList();




  return ok;
}


int Castle::draw(int kt)
{
  int ok=0;

  glPushMatrix();
  glTranslatef(25.3,4.2-WATER_LEVEL,13.3*40/30);

  glCallList(draw_list);







  //LIGHT

  float deform_y = 0.01*powf(cos((float)kt/3.6/2),2);
  float deform_x = 0.01*powf(sin((float)kt/5.4/2),2);

  glPushMatrix();
  glEnable(GL_TEXTURE_2D);
  glDisable(GL_FOG);

  glEnable(GL_BLEND);
  glBlendFunc (GL_ZERO, GL_SRC_COLOR);
  glBindTexture(GL_TEXTURE_2D, texture_number[2]);
  glColor3f(1.0,1.0,1.0);
  glPushMatrix();
  glTranslatef(0.0,WATER_LEVEL,0.0);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0         ,1.0);          glVertex3f(0.0,0.0,0.0-0.002);
  glTexCoord2f(0.0         ,0.0-deform_y); glVertex3f(0.0,1.0,0.0-0.002);
  glTexCoord2f(1.0-deform_x,0.0-deform_y); glVertex3f(1.0,1.0,0.0-0.002);
  glTexCoord2f(1.0-deform_x,1.0);          glVertex3f(1.0,0.0,0.0-0.002);
  glEnd();
  glPopMatrix();
  glDisable(GL_BLEND);

  glEnable(GL_FOG);
  glDisable(GL_TEXTURE_2D);
  glPopMatrix();




  //fire
  glPushMatrix();
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glBindTexture(GL_TEXTURE_2D, texture_number[4]);
  glColor3f(1.0,1.0,1.0);
  glTranslatef(0.0,WATER_LEVEL,0.0);










  int k_x=0;
  float current_time = (float)kt*0.5;
  float texture_kx= (float) ( ((int)current_time)%4);
  float texture_ky= (float) (((int)(current_time/4))%4);

  //two fires
  for(k_x=0;k_x<=1;k_x++)
    {
      glPushMatrix();
      glTranslatef(0.48*k_x,0.0,0.0);
      glBegin(GL_QUADS);
      glTexCoord2f(texture_kx*0.25,texture_ky*0.25+0.25); glVertex3f(0.27-0.03,0.21,-0.07);
      glTexCoord2f(texture_kx*0.25,texture_ky*0.25); glVertex3f(0.27-0.03,0.31,-0.07);
      glTexCoord2f(texture_kx*0.25+0.25,texture_ky*0.25); glVertex3f(0.27+0.03,0.31,-0.07);
      glTexCoord2f(texture_kx*0.25+0.25,texture_ky*0.25+0.25); glVertex3f(0.27+0.03,0.21,-0.07);
      glEnd();
      glPopMatrix();
    }



  glPopMatrix();

  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);


  glPopMatrix();

  return ok;

}






int Castle::set_texture()
{
  int ok=0;

  //**********************//
  //texture 
  //**********************//


  //brick
  glEnable (GL_TEXTURE_2D);
  
  Texture tex;
  ok += tex.load_picture(TEXTURE_BRICK_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[0]));
  glBindTexture (GL_TEXTURE_2D, texture_number[0]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);





  //door
  ok += tex.load_picture(TEXTURE_DOOR_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[1]));
  glBindTexture (GL_TEXTURE_2D, texture_number[1]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    





  //light
  ok += tex.load_picture(TEXTURE_LIGHT_CASTLE_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[2]));
  glBindTexture (GL_TEXTURE_2D, texture_number[2]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    

  glDisable (GL_TEXTURE_2D);





  //lamp
  ok += tex.load_picture(TEXTURE_ROCK_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[3]));
  glBindTexture (GL_TEXTURE_2D, texture_number[3]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    

  glDisable (GL_TEXTURE_2D);


  //fire
  ok += tex.load_picture(TEXTURE_FIRE_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[4]));
  glBindTexture (GL_TEXTURE_2D, texture_number[4]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    

  glDisable (GL_TEXTURE_2D);

  return ok;
}
