#ifndef _Ground_h
#define _Ground_h

#include "library.h"
#include "Texture.h"

#include "Mesh_tool.h"

class Ground
{
 public:
  Ground();
  ~Ground();

  int set_height_field_texture(const char* texture_path_1,const char* texture_path_2);
  int build(int N_x,int N_y,const char* height_field_path);
  int draw();

  float get_height(float _x,float _y);
  int get_normal(float _x,float _y,float *n);
  int set_scale(float scale_x,float scale_y,float scale_z);

  float get_size_x();
  float get_size_y();

 private:

  int destroy();

  int create_call_list();

  Mesh_tool mesh;
  GLuint texture_number[2];
  Texture texture;

  int N_x,N_y;
  
  float scale[3];
  float *height_map;

  GLuint list_number;

};

#endif
