#include "Sky_box.h"

Sky_box::Sky_box()
{
  D=10;
  H=7;
}

Sky_box::~Sky_box()
{
  if(glIsList(draw_list))
    glDeleteLists(draw_list,1);
}

int Sky_box::set_texture()
{
  int ok=0;

  Texture tex;
  ok += tex.load_picture(SKY_BOX_PATH_1);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[0]));
  glBindTexture (GL_TEXTURE_2D, texture_number[0]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);



  ok += tex.load_picture(SKY_BOX_PATH_2);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[1]));
  glBindTexture (GL_TEXTURE_2D, texture_number[1]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  ok += tex.load_picture(SKY_BOX_PATH_3);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[2]));
  glBindTexture (GL_TEXTURE_2D, texture_number[2]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  ok += tex.load_picture(SKY_BOX_PATH_4);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[3]));
  glBindTexture (GL_TEXTURE_2D, texture_number[3]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);



  ok += tex.load_picture(SKY_BOX_PATH_5);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[4]));
  glBindTexture (GL_TEXTURE_2D, texture_number[4]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  //load draw list0
  ok += build_draw_list();

  return ok;
}

int Sky_box::draw()
{
  glCallList(draw_list);
  return 0;
}

int Sky_box::build_draw_list()
{
  int ok=0;

  if(glIsList(draw_list))
    glDeleteLists(draw_list,1);
  draw_list = glGenLists(1);
  glNewList(draw_list,GL_COMPILE);


  glEnable(GL_TEXTURE_2D);


  //color
  glColor4f(1.0,1.0,1.0,1.0);

  //face 1
  glBindTexture (GL_TEXTURE_2D, texture_number[0]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0,1.0); glVertex3f(-D, 0,-D);
  glTexCoord2f(1.0,1.0); glVertex3f(-D, 0, D);
  glTexCoord2f(1.0,0.0); glVertex3f(-D, H, D);
  glTexCoord2f(0.0,0.0); glVertex3f(-D, H,-D);
  glEnd();

  //face 2
  glBindTexture (GL_TEXTURE_2D, texture_number[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(1.0,1.0); glVertex3f(-D, 0,-D);
  glTexCoord2f(0.0,1.0); glVertex3f( D, 0,-D);
  glTexCoord2f(0.0,0.0); glVertex3f( D, H,-D);
  glTexCoord2f(1.0,0.0); glVertex3f(-D, H,-D);
  glEnd();

  //face 3
  glBindTexture (GL_TEXTURE_2D, texture_number[2]);
  glBegin(GL_QUADS);
  glTexCoord2f(1.0,1.0); glVertex3f( D, 0,-D);
  glTexCoord2f(0.0,1.0); glVertex3f( D, 0, D);
  glTexCoord2f(0.0,0.0); glVertex3f( D, H, D);
  glTexCoord2f(1.0,0.0); glVertex3f( D, H,-D);
  glEnd();

  //face 4
  glBindTexture (GL_TEXTURE_2D, texture_number[3]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0,1.0); glVertex3f(-D, 0, D);
  glTexCoord2f(1.0,1.0); glVertex3f( D, 0, D);
  glTexCoord2f(1.0,0.0); glVertex3f( D, H, D);
  glTexCoord2f(0.0,0.0); glVertex3f(-D, H, D);
  glEnd();

  //face 5: top
  glBindTexture (GL_TEXTURE_2D, texture_number[4]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0,1.0); glVertex3f(-D, H,-D);
  glTexCoord2f(0.0,0.0); glVertex3f( D, H,-D);
  glTexCoord2f(1.0,0.0); glVertex3f( D, H, D);
  glTexCoord2f(1.0,1.0); glVertex3f(-D, H, D);
  glEnd();


  glDisable(GL_TEXTURE_2D);


  glEndList();


  return ok;
}
