
#include "Sword.h"


Sword::Sword()
{
  count_animation=0;
}

Sword::~Sword()
{

  if(glIsList(draw_list))
    glDeleteLists(draw_list,1);

}

int Sword::draw(int k_step,Position *position)
{

  if(position->get_is_fight()==false)
    {
      glPushMatrix();
      glLoadIdentity();
      glTranslatef(0.0,0.005*cos((float)k_step/4),0.0);

      glDisable(GL_DEPTH_TEST);
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      glBindTexture(GL_TEXTURE_2D,texture_number[0]);

      glCallList(draw_list);
      
      glDisable(GL_BLEND);
      glDisable(GL_TEXTURE_2D);
      glEnable(GL_DEPTH_TEST);
      glPopMatrix();


      count_animation=0;

    }
  else//animation with sword
    {
      glPushMatrix();
      glLoadIdentity();
      glTranslatef(0.0,0.005*cos((float)k_step/4),0.0);

      glDisable(GL_DEPTH_TEST);
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      glBindTexture(GL_TEXTURE_2D,texture_number[count_animation]);

      glCallList(draw_list);
      
      glDisable(GL_BLEND);
      glDisable(GL_TEXTURE_2D);
      glEnable(GL_DEPTH_TEST);
      glPopMatrix();

      count_animation++;
      if(count_animation>=4)
	{
	  position->disable_fight();
	  count_animation=0;
	}
    }

  return 0;
}


int Sword::set_texture()
{

  int ok=0;


  //**********************//
  //texture 
  //**********************//

  Texture tex;
  ok += tex.load_picture(TEXTURE_SWORD_PATH);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[0]));
  glBindTexture (GL_TEXTURE_2D, texture_number[0]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);













  ok += tex.load_picture(TEXTURE_SWORD_ANIMATE_PATH_1);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[1]));
  glBindTexture (GL_TEXTURE_2D, texture_number[1]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);



  ok += tex.load_picture(TEXTURE_SWORD_ANIMATE_PATH_2);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[2]));
  glBindTexture (GL_TEXTURE_2D, texture_number[2]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  ok += tex.load_picture(TEXTURE_SWORD_ANIMATE_PATH_3);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[3]));
  glBindTexture (GL_TEXTURE_2D, texture_number[3]);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  ok += build_draw_list();

  return ok;
}


int Sword::build_draw_list()
{
  
  int ok=0;

  if(glIsList(draw_list))
    glDeleteLists(draw_list,1);
  draw_list = glGenLists(1);
  glNewList(draw_list,GL_COMPILE);


  glColor4f(1.0,1.0,1.0,1.0);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0,0.9); glVertex3f(-0.5,-0.5, -1);
  glTexCoord2f(0.0,0.0); glVertex3f(-0.5, 0.5, -1);
  glTexCoord2f(1.0,0.0); glVertex3f( 0.5, 0.5, -1);
  glTexCoord2f(1.0,0.9); glVertex3f( 0.5,-0.5, -1);
  glEnd();

  glEndList();

  

  return ok;
}
