#ifndef _Texture_h
#define _Texture_h

#include <iostream>
#include <string>
#include <cmath>
#include <errno.h>
#include "library.h"

#include <png.h> /* PNG library definitions */

#define MAX_SIZE_EXTENSION 15
#define SIZE_BUFFER 100


using namespace std;

class Texture
{
 public:
  Texture();
  ~Texture();

  int load_picture(const char* file_name);
  int export_ppm(const char* file_name);

  int get_Nx();
  int get_Ny();
  unsigned char* get_data();
  int get_nearest_texel(float s_1,float s_2,float *texel);
  int get_linear_texel(float s_1,float s_2,float *texel);
 private:

  int load_png_picture(const char* file_name);
  int destroy();

  unsigned char *picture;
  int N_x,N_y;
};

#endif
