#include "Transparent_elements.h"


Transparent_elements::Transparent_elements()
{
  position=NULL;
  scale=NULL;
  new_z=NULL;
  index_z=NULL;

}

int Transparent_elements::destroy()
{
  if(position!=NULL)
    {
      delete[] position;
      position=NULL;
    }
  if(scale!=NULL)
    {
      delete[] scale;
      scale=NULL;
    }
  if(new_z!=NULL)
    {
      delete[] new_z;
      new_z=NULL;
    }
  if(index_z!=NULL)
    {
      delete[] index_z;
      index_z=NULL;
    }

  return 0;
}

Transparent_elements::~Transparent_elements()
{
  if(destroy()!=0)
    cout<<"ERROR DELETE Transparent elements\n";
}

int Transparent_elements::load_transparent_file()
{
  int ok=0;

  int N_0=0,N_1=0,N_2=0,N_3=0;


  ok += get_size_element(SAVE_TREE_1_PATH,&N_0);
  ok += get_size_element(SAVE_TREE_2_PATH,&N_1);
  ok += get_size_element(SAVE_ANIMAL_1_PATH,&N_2);
  ok += get_size_element(SAVE_QUAD_1_PATH,&N_3);

  N_total=N_0+N_1+N_2+N_3;


  //allocation:
  position = new float[3*N_total];
  scale    = new float[2*N_total];
  new_z    = new float[N_total];
  index_z  = new int  [N_total];

 

  if(index_z==NULL || new_z==NULL || scale==NULL || position==NULL)
    {
      cout<<"ERROR allocation in transparent elements\n";
      exit(-1);
    }

  for(int k=0;k<N_total;k++)
      index_z[k]=k;


  load_position(SAVE_TREE_1_PATH,0,&(N[0]));
  load_position(SAVE_TREE_2_PATH,N[0],&(N[1]));
  load_position(SAVE_ANIMAL_1_PATH,(N[0]+N[1]),&(N[2]));
  load_position(SAVE_QUAD_1_PATH,(N[0]+N[1]+N[2]),&(N[3]));
  

  return ok;
}

int Transparent_elements::get_size_element(const char* filename,int *_N)
{
  int ok=0;
  FILE *fid=NULL;

  fid = fopen(filename,"r");
  if(fid==NULL)
    {
      printf("ERROR CANNOT OPEN %s in get_size_element\n",filename);
      exit(-1);
    }
  fscanf(fid,"%d\n",_N);
  fclose(fid);

  return ok;
}

int Transparent_elements::set_number(int N_1,int N_2,int N_3,int N_4)
{
  int ok=0;

  ok+=destroy();

  N[0]=N_1;
  N[1]=N_2;
  N[2]=N_3;
  N[3]=N_4;

  N_total=N_1+N_2+N_3+N_4;

  if(N_1<0 || N_2<0 || N_3<0)
    {
      cout<<"ERROR set number of transparent elements\n";
      exit(-1);
    }
  
  //allocation:
  position = new float[3*N_total];
  scale    = new float[2*N_total];
  new_z    = new float[N_total];
  index_z    = new int  [N_total];


 

  if(index_z==NULL || new_z==NULL || scale==NULL || position==NULL)
    {
      cout<<"ERROR allocation in transparent elements\n";
      exit(-1);
    }

  for(int k=0;k<N_total;k++)
      index_z[k]=k;



  return ok;
}





int Transparent_elements::set_texture(const char* texture_path_1,const char* texture_path_2,const char* texture_path_3,const char* texture_path_4)
{
  int ok=0;






  //load texture 1
  //**********************//
  Texture tex;
  tex.load_picture(texture_path_1);

  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[0]));
  glBindTexture (GL_TEXTURE_2D, texture_number[0]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);




  //load texture 2
  //**********************//

  //  Texture tex2;
  tex.load_picture(texture_path_2);


  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[1]));
  glBindTexture (GL_TEXTURE_2D, texture_number[1]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);





  //load texture 3
  //**********************//
  tex.load_picture(texture_path_3);

  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[2]));
  glBindTexture (GL_TEXTURE_2D, texture_number[2]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);



  //load texture 4
  //**********************//
  tex.load_picture(texture_path_4);

  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glGenTextures (1, &(texture_number[3]));
  glBindTexture (GL_TEXTURE_2D, texture_number[3]);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  gluBuild2DMipmaps (GL_TEXTURE_2D, 4, tex.get_Nx(), tex.get_Ny(), GL_RGBA,
                         GL_UNSIGNED_BYTE, tex.get_data());
  glTexEnvi (GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_REPLACE);


  return ok;
}


int Transparent_elements::set_matrix(GLfloat *view_matrix,Position *camera_position)
{
  int ok=0;



  //fill matrix and right and up direction for billboards
  right[0] = view_matrix[0]/2;
  right[1] = view_matrix[4]/2;
  right[2] = view_matrix[8]/2;

  up[0] = view_matrix[1];
  up[1] = view_matrix[5];
  up[2] = view_matrix[9];

  int k=0;
  for(k=0;k<16;k++)
    matrix[k] = view_matrix[k];

  //sort
  ok += sort_positions(camera_position);

  return ok;
  
}


int Transparent_elements::set_position(Ground *ground)
{
  
  int ok=0;
  


  //get dimensions
  //************************//
  float max_x = ground->get_size_x();
  float max_y = ground->get_size_y();




  //set Billboards
  //************************//
  int k_billboard=0;
  for(k_billboard=0;k_billboard<N[0];k_billboard++)
    {
      position[3*k_billboard+0] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_x;
      position[3*k_billboard+2] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_y;
      position[3*k_billboard+1] = ground->get_height(position[3*k_billboard+0],position[3*k_billboard+2]);

      scale[2*k_billboard+0] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*6.5;
      scale[2*k_billboard+1] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*6.5;

      if(position[3*k_billboard+1] == WATER_LEVEL)
	 k_billboard--;
    }
  export_position("tree_1.dat",position,scale,N[0]);

  //set Tree 2
  //************************//
  for(k_billboard=N[0];k_billboard<N[0]+N[1];k_billboard++)
    {
      position[3*k_billboard+0] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_x;
      position[3*k_billboard+2] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_y;
      position[3*k_billboard+1] = ground->get_height(position[3*k_billboard+0],position[3*k_billboard+2]);

      scale[2*k_billboard+0] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*6.5;
      scale[2*k_billboard+1] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*6.5;

      if(position[3*k_billboard+1] == WATER_LEVEL)
	 k_billboard--;

    }
  export_position("tree_2.dat",position+3*N[0],scale+2*N[0],N[1]);

  //set Animal 1
  //************************//
  for(k_billboard=N[0]+N[1];k_billboard<N[0]+N[1]+N[2];k_billboard++)
    {
      position[3*k_billboard+0] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_x;
      position[3*k_billboard+2] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_y;
      position[3*k_billboard+1] = ground->get_height(position[3*k_billboard+0],position[3*k_billboard+2]);

      scale[2*k_billboard+0] = 0.15;
      scale[2*k_billboard+1] = 0.15*0.64188;
      if(position[3*k_billboard+1] == WATER_LEVEL)
	 k_billboard--;

    }
  export_position("animal_1.dat",position+3*(N[0]+N[1]),scale+2*(N[0]+N[1]),N[2]);

  //set Quads
  //************************//
  int k_quad=0;
  for(k_quad=N[0]+N[1]+N[2];k_quad<N[0]+N[1]+N[2]+N[3];k_quad++)
    {
      position[3*k_quad+0] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_x;
      position[3*k_quad+2] = (float)(rand()%PRECISION_RAND)/(PRECISION_RAND)*max_y;
      position[3*k_quad+1] = ground->get_height(position[3*k_quad+0],position[3*k_quad+2]);

      scale[2*k_quad+0] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*2.5;
      scale[2*k_quad+1] = ((float)(rand()%PRECISION_RAND)/(PRECISION_RAND)+1)*0.1/2*2.5;
      if(position[3*k_quad+1] == WATER_LEVEL)
	 k_quad--;
    }
  export_position("quads_1.dat",position+3*(N[0]+N[1]+N[2]),scale+2*(N[0]+N[1]+N[2]),N[3]);





//   int k=0;
//   for(k=0;k<N[0]+N[1]+N[2]+N[3];k++)
//     position[3*k+1] = ground->get_height(position[3*k+0],position[3*k+2]);
    

  return ok;

}

int Transparent_elements::sort_positions(Position *camera_position)
{
  int ok=0;

  int k=0;

  //load new z and index
  int count=0;

  float d;
  for(k=0;k<N_total;k++)
    {
      new_z[k] = matrix[2]*position[3*k]+matrix[6]*position[3*k+1]+matrix[10]*position[3*k+2]+matrix[14];
      //sort only in a defined perimeter
      if(new_z[k]<0)
	{
	  d=pow(camera_position->get_x()-position[3*k],2)+pow(camera_position->get_z()-position[3*k+2],2);
	  if(d<PERIMETER_VISU_TRANSPARENT)
	    {

	      index_z[count]=k;
	      count++;
	    }
	}
    }
  limit=count;

  //sort
  ok += comparator.set_pointer(&new_z);
  if(limit>0)
    sort(index_z,index_z+limit,comparator);

  return ok;
}

int Transparent_elements::draw(int kt)
{
  int ok=0;
  int k_inverse=0;

  float deform_x=0.0,deform_z=0.0;

  glEnable (GL_TEXTURE_2D);//texture
  glEnable (GL_BLEND);//blending
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDepthMask(GL_FALSE);//reading only




  int k=0;
  int k_draw=0;



  for(k=0;k<limit;k++)
    {
      k_draw = index_z[k];

      //Draw Billboard
      if(k_draw<N[0]+N[1]+N[2])
	{
	  k_inverse = k_draw%2;
	  //set billboard texture
	  if(k_draw<N[0])//tree
	    glBindTexture(GL_TEXTURE_2D,texture_number[0]);
	  else
	    {
	      if(k_draw<N[0]+N[1])//tree 2
		glBindTexture(GL_TEXTURE_2D,texture_number[1]);
	      else//animal
		glBindTexture(GL_TEXTURE_2D,texture_number[2]);
	    }

	  //draw
	  glPushMatrix();
	  glTranslatef(position[3*k_draw],position[3*k_draw+1],position[3*k_draw+2]);
	  glBegin (GL_QUADS);
	  glTexCoord2f(0.0+k_inverse,1.0); glVertex3f(-right[0]*scale[2*k_draw+0],-right[1]*scale[2*k_draw+0],-right[2]*scale[2*k_draw+0]);
	  glTexCoord2f(1.0-k_inverse,1.0); glVertex3f(right[0]*scale[2*k_draw+0],right[1]*scale[2*k_draw+0],right[2]*scale[2*k_draw+0]);
	  glTexCoord2f(1.0-k_inverse,0.0); glVertex3f(right[0]*scale[2*k_draw+0]+up[0]*scale[2*k_draw+1],right[1]*scale[2*k_draw+0]+up[1]*scale[2*k_draw+1],right[2]*scale[2*k_draw+0]+up[2]*scale[2*k_draw+1]);
	  glTexCoord2f(0.0+k_inverse,0.0); glVertex3f(-right[0]*scale[2*k_draw+0]+up[0]*scale[2*k_draw+1],-right[1]*scale[2*k_draw+0]+up[1]*scale[2*k_draw+1],-right[2]*scale[2*k_draw+0]+up[2]*scale[2*k_draw+1]);
	  glEnd();
	  glPopMatrix();

	}
      //Draw Quads
      if(k_draw>=N[0]+N[1]+N[2] && k_draw<N[0]+N[1]+N[2]+N[3])//then Quad
	{
	  //set quad texture
	  glBindTexture(GL_TEXTURE_2D,texture_number[3]);
	  
	  //draw
	  glPushMatrix();
	  glTranslatef(position[3*k_draw],position[3*k_draw+1],position[3*k_draw+2]);




	  //	  float deform_x=cos((float)kt/10-position[3*k_draw]*2-position[3*k_draw+2]*1.24)*0.05;
	  //	  float deform_z = cos((float)kt/9.6-position[3*k_draw]*2.4)*0.03;

	  deform_x=cos((float)kt/10-position[3*k_draw]*2*0.6-position[3*k_draw+2]*1.24*0.6)*0.05;
	  deform_z = cos((float)kt/9.6-position[3*k_draw]*2.4*0.6)*0.03;

	  glBegin(GL_TRIANGLES);
	  glTexCoord2f(0.0,1.0); glVertex3f(-scale[2*k_draw]/2,0.0,0);
	  glTexCoord2f(0.0,0.0); glVertex3f(-scale[2*k_draw]/2,scale[2*k_draw+1],0);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);

	  glTexCoord2f(0.0,1.0); glVertex3f(-scale[2*k_draw]/2,0.0,0);
	  glTexCoord2f(0.5,1.0); glVertex3f( 0.0,0.0,0);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);

	  glTexCoord2f(0.5,1.0); glVertex3f( 0,0.0,0);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);
	  glTexCoord2f(1.0,1.0); glVertex3f( scale[2*k_draw]/2,0.0,0);

	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);
	  glTexCoord2f(1.0,0.0); glVertex3f( scale[2*k_draw]/2,scale[2*k_draw+1],0);
	  glTexCoord2f(1.0,1.0); glVertex3f( scale[2*k_draw]/2,0.0,0);




	  glTexCoord2f(0.0,1.0); glVertex3f(0.0,0.0,-scale[2*k_draw]/2);
	  glTexCoord2f(0.0,0.0); glVertex3f(0.0,scale[2*k_draw+1],-scale[2*k_draw]/2);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);

	  glTexCoord2f(0.0,1.0); glVertex3f( 0.0,0.0,-scale[2*k_draw]/2);
	  glTexCoord2f(0.5,1.0); glVertex3f( 0.0,0.0,0);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);


	  glTexCoord2f(0.5,1.0); glVertex3f( 0,0.0,0);
	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);
	  glTexCoord2f(1.0,1.0); glVertex3f( 0.0,0.0,scale[2*k_draw]/2);

	  glTexCoord2f(0.5,0.0); glVertex3f( 0+deform_x,scale[2*k_draw+1],0+deform_z);
	  glTexCoord2f(1.0,0.0); glVertex3f( 0.0,scale[2*k_draw+1],scale[2*k_draw]/2);
	  glTexCoord2f(1.0,1.0); glVertex3f( 0.0,0.0,scale[2*k_draw]/2);


	  glEnd();
	  glPopMatrix();

	}

    }




  //disable
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);


  return ok;
}


int Transparent_elements::export_position(const char* file_path,float *object_position,float *scale_position,int number)
{
  int ok=0;

  FILE *fid=NULL;
  fid = fopen(file_path,"w");
  if(fid==NULL)
    {
      cout<<"ERROR CANNOT CREATE "<<file_path<<"\n";
      return(-1);
    }

  fprintf(fid,"%d\n",number);
  int k=0;
  for(k=0;k<number;k++)
    fprintf(fid,"%f %f %f %f %f\n",object_position[3*k],object_position[3*k+1],object_position[3*k+2],scale_position[2*k],scale_position[2*k+1]);

  fclose(fid);
  

  return ok;
}




int Transparent_elements::load_position(const char* file_path,int start,int *end)
{
  int ok=0;
  char buffer_1[100],buffer_2[100],buffer_3[100];
  char buffer_4[100],buffer_5[100];


  FILE *fid=NULL;
  fid = fopen(file_path,"r");
  if(fid==NULL)
    {
      cout<<"ERROR CANNOT READ "<<file_path<<"\n";
      return(-1);
    }

  fscanf(fid,"%d\n",end);

  int k=0;
  for(k=0;k<*end;k++)
    {
      fscanf(fid,"%s %s %s %s %s\n",buffer_1,buffer_2,buffer_3,buffer_4,buffer_5);
      position[3*k+0+3*start]=strtod((const char*)buffer_1,NULL);
      position[3*k+1+3*start]=strtod((const char*)buffer_2,NULL);
      position[3*k+2+3*start]=strtod((const char*)buffer_3,NULL);
      scale[2*k+0+2*start]=strtod((const char*)buffer_4,NULL);
      scale[2*k+1+2*start]=strtod((const char*)buffer_5,NULL);
    }
  fclose(fid);
  

  return ok;
}

