#ifndef _Transparent_elements_h
#define _Transparent_elements_h

#include "library.h"
#include "Ground.h"
#include "Comparator.h"
#include "Position.h"

class Transparent_elements
{
 public:
  Transparent_elements();
  ~Transparent_elements();

  int set_number(int N_1,int N_2,int N_3,int N_4);

  int set_position(Ground *_position);
  int set_matrix(GLfloat *matrix,Position *camera_position);
  int set_texture(const char* texture_path_1,const char* texture_path_2,const char* texture_path_3,const char* texture_path_4);
  int draw(int kt);

  int load_transparent_file();

  int export_position(const char* file_path,float *object_position,float *object_scale,int number);



 private:

  int destroy();
  int sort_positions(Position *camera_position);

  int get_size_element(const char* filename,int *_N);
  int load_position(const char* file_path,int start,int *end);

  int N[NUMBER_TRANSPARENT_TYPE];
  int N_total;
  float *position;
  float *scale;

  float up[3];
  float right[3];

  float *new_z;

  float matrix[16];

  GLuint texture_number[NUMBER_TRANSPARENT_TYPE];

  int *index_z;
  Comparator comparator;

  int limit;
};
#endif
