
#ifndef _library_h
#define _library_h

#include <stdlib.h>
#include <iostream>
#include <GL/glut.h>
#include <cmath>
#include <string>
#include <errno.h>

using namespace std;


#define PRECISION_RAND 1000000

#define PI 3.14159

//scale of the texture of the water
#define LAMBDA_WATER 6
#define WATER_LEVEL 1.00
#define NUMBER_TRANSPARENT_TYPE 4
#define PERIMETER_VISU_TRANSPARENT 10*10


#define GLUT_SPACE 32//to have a look!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



//Textures path
//**************************//

//ground
#define TEXTURE_GROUND_PATH        "textures/ground/map_gray.png"
#define TEXTURE_GROUND_COLOR_PATH  "textures/ground/map_colored.png"
#define TEXTURE_GROUND_GRASS_PATH  "textures/ground/map_grass.png"

//transparent vegetation and animal
#define TEXTURE_BILLBOARD_PATH_1       "textures/transparent_textures/tree_1.png"
#define TEXTURE_BILLBOARD_PATH_2       "textures/transparent_textures/tree_2.png"
#define TEXTURE_BILLBOARD_PATH_3       "textures/transparent_textures/animal.png"
#define TEXTURE_TRANSPARENT_GRASS_PATH "textures/transparent_textures/grass.png"

//grass
#define TEXTURE_GRASS_PATH "textures/grass/grass.png"

//water
#define TEXTURE_WATER_PATH "textures/water/water.png"

//sky box
#define SKY_BOX_PATH_1 "textures/sky_box/neg_x.png"
#define SKY_BOX_PATH_2 "textures/sky_box/neg_z.png"
#define SKY_BOX_PATH_3 "textures/sky_box/pos_x.png"
#define SKY_BOX_PATH_4 "textures/sky_box/pos_z.png"
#define SKY_BOX_PATH_5 "textures/sky_box/pos_y.png"

//castle
#define TEXTURE_BRICK_PATH        "textures/castle/brick.png"
#define TEXTURE_DOOR_PATH         "textures/castle/door.png"
#define TEXTURE_LIGHT_CASTLE_PATH "textures/castle/light.png"
#define TEXTURE_ROCK_PATH         "textures/castle/rock.png"
#define TEXTURE_FIRE_PATH         "textures/castle/fire.png"

//sword
#define TEXTURE_SWORD_PATH           "textures/sword/sword_rest.png"
#define TEXTURE_SWORD_ANIMATE_PATH_1 "textures/sword/sword_animate_1.png"
#define TEXTURE_SWORD_ANIMATE_PATH_2 "textures/sword/sword_animate_2.png"
#define TEXTURE_SWORD_ANIMATE_PATH_3 "textures/sword/sword_animate_3.png"


//Rabit and Dragon
#define TEXTURE_MESH3D_PATH "textures/others/rabit_dragon.png"


//MESH 3D
//******************************//

#define MESH_RABIT_PATH  "mesh_3D/rabit.ply"
#define MESH_DRAGON_PATH "mesh_3D/dragon.ply"

//SAVE position
//******************************//

#define SAVE_TREE_1_PATH    "save_position/tree_1.dat"
#define SAVE_TREE_2_PATH    "save_position/tree_2.dat"
#define SAVE_ANIMAL_1_PATH  "save_position/animal_1.dat"
#define SAVE_QUAD_1_PATH    "save_position/quads_1.dat"




#endif
